# Connection: root
# Host: localhost
# Saved: 2004-01-21 16:50:41
# 
# Host: localhost
# Database: nuke
# Table: 'nuke_contractual_attitude'
# 
CREATE TABLE `nuke_contractual_attitude` (
  `attitudeid` int(3) NOT NULL auto_increment,
  `attitude` varchar(80) NOT NULL default '',
  PRIMARY KEY  (`attitudeid`)
) TYPE=MyISAM; 

# Host: localhost
# Database: nuke
# Table: 'nuke_contractual_branch'
# 
CREATE TABLE `nuke_contractual_branch` (
  `branchid` int(6) NOT NULL auto_increment,
  `branchno` int(8) NOT NULL default '0',
  `branch` varchar(120) NOT NULL default 'leer',
  PRIMARY KEY  (`branchid`)
) TYPE=MyISAM; 

# Host: localhost
# Database: nuke
# Table: 'nuke_contractual_contact'
# 
CREATE TABLE `nuke_contractual_contact` (
  `contactid` int(10) NOT NULL auto_increment,
  `name` varchar(60) NOT NULL default '',
  `firstname` varchar(60) default NULL,
  `company` varchar(90) default NULL,
  `contactcelltel` varchar(15) default NULL,
  `contacttel` varchar(15) default NULL,
  `contactfax` varchar(15) default NULL,
  `contactemail` varchar(50) default NULL,
  `contactweb` varchar(100) default NULL,
  `contactzip` varchar(15) default NULL,
  `contactstreet` varchar(120) default NULL,
  `contactarea` varchar(50) default NULL,
  `contactstate` varchar(80) default NULL,
  `contactcity` varchar(80) default NULL,
  `function` varchar(100) default NULL,
  `role` varchar(100) default NULL,
  `attitude` varchar(80) default NULL,
  PRIMARY KEY  (`contactid`)
) TYPE=MyISAM; 

# Host: localhost
# Database: nuke
# Table: 'nuke_contractual_contract'
# 
CREATE TABLE `nuke_contractual_contract` (
  `contractid` int(10) NOT NULL auto_increment,
  `contract` varchar(255) NOT NULL default '',
  `info` text,
  `contracttype` varchar(100) default NULL,
  `project` varchar(100) default NULL,
  `payperiod` varchar(60) default NULL,
  `executionperiod` varchar(60) default NULL,
  `priceperperiode` double(12,2) default '0.00',
  `startdate` date default '0000-00-00',
  `enddate` date default '0000-00-00',
  `termofnotice` int(3) default NULL,
  `prolongationperiode` int(3) default NULL,
  `company` varchar(20) default NULL,
  PRIMARY KEY  (`contractid`)
) TYPE=MyISAM; 

# Host: localhost
# Database: nuke
# Table: 'nuke_contractual_contracttype'
# 
CREATE TABLE `nuke_contractual_contracttype` (
  `typeid` int(4) NOT NULL auto_increment,
  `contracttype` varchar(100) NOT NULL default '',
  PRIMARY KEY  (`typeid`)
) TYPE=MyISAM; 

# Host: localhost
# Database: nuke
# Table: 'nuke_contractual_decision'
# 
CREATE TABLE `nuke_contractual_decision` (
  `decid` int(1) NOT NULL auto_increment,
  `decision` varchar(12) NOT NULL default '',
  PRIMARY KEY  (`decid`)
) TYPE=MyISAM; 

# Host: localhost
# Database: nuke
# Table: 'nuke_contractual_execution'
# 
CREATE TABLE `nuke_contractual_execution` (
  `executionid` int(9) NOT NULL auto_increment,
  `executionyes` varchar(12) NOT NULL default '',
  `contractid` int(10) NOT NULL default '0',
  `executiondate` date default '0000-00-00',
  PRIMARY KEY  (`executionid`)
) TYPE=MyISAM; 

# Host: localhost
# Database: nuke
# Table: 'nuke_contractual_executionperiod'
# 
CREATE TABLE `nuke_contractual_executionperiod` (
  `exeid` int(3) NOT NULL auto_increment,
  `executionperiod` varchar(60) NOT NULL default '',
  PRIMARY KEY  (`exeid`)
) TYPE=MyISAM; 

# Host: localhost
# Database: nuke
# Table: 'nuke_contractual_function'
# 
CREATE TABLE `nuke_contractual_function` (
  `functionid` int(3) NOT NULL auto_increment,
  `function` varchar(100) NOT NULL default '',
  PRIMARY KEY  (`functionid`)
) TYPE=MyISAM; 

# Host: localhost
# Database: nuke
# Table: 'nuke_contractual_partners'
# 
CREATE TABLE `nuke_contractual_partners` (
  `companyid` int(10) NOT NULL auto_increment,
  `company` varchar(90) NOT NULL default '',
  `branch` varchar(120) default NULL,
  `celltel` varchar(15) default NULL,
  `tel` varchar(15) default NULL,
  `fax` varchar(15) default NULL,
  `email` varchar(50) default NULL,
  `web` varchar(100) default NULL,
  `street` varchar(120) default NULL,
  `zip` varchar(15) default NULL,
  `area` varchar(50) default NULL,
  `state` varchar(80) default NULL,
  `city` varchar(80) default NULL,
  `searchname` varchar(20) NOT NULL default '',
  `text` text,
  PRIMARY KEY  (`companyid`)
) TYPE=MyISAM; 

# Host: localhost
# Database: nuke
# Table: 'nuke_contractual_payperiod'
# 
CREATE TABLE `nuke_contractual_payperiod` (
  `payid` int(3) NOT NULL auto_increment,
  `payperiod` varchar(60) NOT NULL default '',
  PRIMARY KEY  (`payid`)
) TYPE=MyISAM; 

# Host: localhost
# Database: nuke
# Table: 'nuke_contractual_project'
# 
CREATE TABLE `nuke_contractual_project` (
  `projectid` int(10) NOT NULL auto_increment,
  `projectno` int(10) default NULL,
  `project` varchar(100) NOT NULL default '',
  `projectcity` varchar(80) default NULL,
  `projectzip` varchar(15) default NULL,
  `projectstreet` varchar(80) default NULL,
  PRIMARY KEY  (`projectid`)
) TYPE=MyISAM; 

# Host: localhost
# Database: nuke
# Table: 'nuke_contractual_region'
# 
CREATE TABLE `nuke_contractual_region` (
  `regionid` int(3) NOT NULL default '0',
  `region` varchar(50) NOT NULL default 'ohne',
  PRIMARY KEY  (`region`)
) TYPE=MyISAM; 

# Host: localhost
# Database: nuke
# Table: 'nuke_contractual_role'
# 
CREATE TABLE `nuke_contractual_role` (
  `roleid` int(3) NOT NULL auto_increment,
  `role` varchar(100) NOT NULL default '',
  PRIMARY KEY  (`roleid`)
) TYPE=MyISAM; 

# Host: localhost
# Database: nuke
# Table: 'nuke_contractual_states'
# 
CREATE TABLE `nuke_contractual_states` (
  `stateid` int(3) NOT NULL auto_increment,
  `state` varchar(100) NOT NULL default '',
  `currency` varchar(30) NOT NULL default '',
  `currencysign` char(3) NOT NULL default '?',
  PRIMARY KEY  (`stateid`)
) TYPE=MyISAM; 

# Host: localhost
# Database: nuke
# Table: 'nuke_contractual_town'
# 
CREATE TABLE `nuke_contractual_town` (
  `townid` int(6) NOT NULL auto_increment,
  `town` varchar(80) NOT NULL default '',
  PRIMARY KEY  (`townid`)
) TYPE=MyISAM; 

